import numpy as np
from sklearn import preprocessing, cross_validation,svm
import pandas as pd
from sklearn.decomposition import PCA
from DEAP.GuoK_KandraH_Paper.DWT_analysis import svm_dwt_plot as data

accuracy_final = np.array([])
for i in range(1, 32):
    if i < 10:
        b = '0' + str(i)
    else:
        b = str(i)
    f = 'testfile_' + b + '.txt'

    df = pd.read_csv('data/'+f)
    df.drop(['user'], 1, inplace=True)
    df.drop(['video'], 1, inplace=True)

    X = np.array(df.drop(['op'], 1))
    y = np.array(df['op'])
    X_train, X_test, y_train, y_test = cross_validation.train_test_split(X, y, test_size=0.2)
    pca = PCA(n_components=2)  # adjust yourself
    pca.fit(X_train)
    X_t_train = pca.transform(X_train)
    X_t_test = pca.transform(X_test)
    lin_clf = svm.SVC(C=1.0, cache_size=200, class_weight=None, coef0=0.0,
                      decision_function_shape='ovo', degree=3, gamma='auto', kernel='sigmoid',
                      max_iter=-1, probability=False, random_state=None, shrinking=True,
                      tol=0.001, verbose=False)

    clf = svm.SVC(C=1.0, cache_size=200, class_weight=None, coef0=0.0,
              decision_function_shape='ovo', degree=3, gamma='auto', kernel='sigmoid',
              max_iter=-1, probability=False, random_state=None, shrinking=True,
              tol=0.001, verbose=False)
    clf.fit(X_train, y_train)
    accuracy = clf.score(X_test, y_test)
    accuracy_final = np.append(accuracy_final, accuracy)
    print("\nn: ", i)
    print("\nAcurracy: ", accuracy)

mean_arousal = np.mean(accuracy_final)*100
print("\nMean Acurracy: " + "%.2f" % mean_arousal)
print("\nSTD:\n", np.std(accuracy_final))


