from riemannian_utils.file import csv_File
from riemannian_utils.tangentspace_svm import Frequencies
import numpy as np
import scipy.io
import os


name_file = 'SVM-TS-OFICIAL-15-36HZ'

path = '/Users/ricklicona/Downloads/DEAPDataset/data_preprocessed_matlab/'
total_elements_class0 = np.array(())
total_elements_class1 = np.array(())

total_elements_class0_0 = np.array(())
total_elements_class1_1 = np.array(())
#3
valence_Score_Acc_3 = np.array(())
valence_STD_3= np.array(())

arousal_Score_Acc_3 = np.array(())
arousal_STD_3 = np.array(())

subjects = np.array(())

for s in range(1, 33):
    if s < 10:
        b = '0' + str(s)
    else:
        b = str(s)
    subject = path+'s'+b+'.mat'

    mat = scipy.io.loadmat(subject)
    X = np.array(mat['data'])
    X = X[:, :32, :]

    #SHAPE (40, 4)
    y = np.array(mat['labels'])

    #SHAPE (40, )
    y_valence = y[:, 0]
    y_valence = (y_valence > 5).astype(np.int_)

    y_arousal = y[:, 1]
    y_arousal = (y_arousal > 5).astype(np.int_)
    total_elements_class0 = np.append(total_elements_class0, np.count_nonzero(y_valence == 0))
    total_elements_class1 = np.append(total_elements_class1, np.count_nonzero(y_valence == 1))

    total_elements_class0_0 = np.append(total_elements_class0, np.count_nonzero(y_arousal == 0))
    total_elements_class1_1 = np.append(total_elements_class1, np.count_nonzero(y_arousal == 1))

    print("SUBJECT:", s)
    print("Elements_class_0: ", np.count_nonzero(y_valence == 0))
    print("Elements_class_1: ", np.count_nonzero(y_valence == 1))

    valence_Score_Acc_R3, valence_STD_R3, arousal_Score_Acc_R3, arousal_STD_R3 = Frequencies().getAlfa_Beta_Gamma(X, s, y_valence, y_arousal)

    valence_Score_Acc_3 = np.append(valence_Score_Acc_3, valence_Score_Acc_R3)
    valence_STD_3 = np.append(valence_STD_3, valence_STD_R3)

    arousal_Score_Acc_3 = np.append(arousal_Score_Acc_3, arousal_Score_Acc_R3)
    arousal_STD_3 = np.append(arousal_STD_3, arousal_STD_R3)

    print("------------------------------------------------------------------------")
    print("Perfomance Mean Valence (3): ", np.mean(valence_Score_Acc_3), "STD: ", np.mean(valence_STD_3))
    print("Perfomance Mean Arousal (3): ", np.mean(arousal_Score_Acc_3), "STD: ", np.mean(arousal_STD_3))
    subjects = np.append(subjects, s)

class_0_LOW = total_elements_class0.sum()
class_1_HIGH = total_elements_class1.sum()

class_0_0_LOW = total_elements_class0_0.sum()
class_1_1_HIGH = total_elements_class1_1.sum()

csv_File().generate3(subjects, valence_Score_Acc_3, valence_STD_3, arousal_Score_Acc_3, arousal_STD_3,
                     name_file)

print("\nTotal Class 0 (LOW VALENCE): ", class_0_LOW)
print("Total Class 1 (HIGH VALENCE): ", class_1_HIGH)

print("\nTotal Class 0 (LOW AROUSAL): ", class_0_0_LOW)
print("Total Class 1 (HIGH AROUSAL): ", class_1_1_HIGH)


os.system('say SVM acabado')





