from riemannian_utils.file import csv_File
from riemannian_utils.lr_no_ts import Frequencies
import numpy as np
import scipy.io
import os

name_file = 'LR-NO-TS-OFICIAL-15-36HZ'

path = '/Users/ricklicona/PycharmProjects/deap_pBCI_Riemannian/DEAP/RIEMANNIAN_MDM/files_segmentation_10s/'
total_elements_class0 = np.array(())
total_elements_class1 = np.array(())

total_elements_class0_0 = np.array(())
total_elements_class1_1 = np.array(())

valence_Score_Acc_3 = np.array(())

arousal_Score_Acc_3 = np.array(())

subjects = np.array(())
for s in range(1, 33):
    if s < 10:
        b = str(s)
    else:
        b = str(s)
    subject = path+'eeg_ch_'+b+'.mat'

    file = scipy.io.loadmat(subject)
    print("NAME FILE: ", subject)

    labels_valence = file['labels_valence'].ravel()
    labels_valence = labels_valence.astype(int)
    labels_valence = (labels_valence == 2).astype(np.int_)

    labels_arousal = file['labels_arousal'].ravel()
    labels_arousal = labels_arousal.astype(int)
    labels_arousal = (labels_arousal == 2).astype(np.int_)

    data = file['data']


    #labelsV2 = np.count_nonzero(labels_valence == 1)  # HIGH VALANCE
    #labelsV1 = np.count_nonzero(labels_valence == 0)  # LOW VALANCE

    #print("v2: ", labelsV2, 'v1', labelsV1)
    total_elements_class0 = np.append(total_elements_class0, np.count_nonzero(labels_valence == 0))
    total_elements_class1 = np.append(total_elements_class1, np.count_nonzero(labels_valence == 1))

    total_elements_class0_0 = np.append(total_elements_class0, np.count_nonzero(labels_arousal == 0))
    total_elements_class1_1 = np.append(total_elements_class1, np.count_nonzero(labels_arousal == 1))
    print("Channel:", s)
    print("Elements_class_0: ", np.count_nonzero(labels_valence == 0))
    print("Elements_class_1: ", np.count_nonzero(labels_valence == 1))

    valence_Score_Acc_R3, arousal_Score_Acc_R3 = Frequencies().getAlfa_Beta_Gamma(data, s, labels_valence, labels_arousal)

    valence_Score_Acc_3 = np.append(valence_Score_Acc_3, valence_Score_Acc_R3)

    arousal_Score_Acc_3 = np.append(arousal_Score_Acc_3, arousal_Score_Acc_R3)

    print("------------------------------------------------------------------------")
    print("Perfomance Mean Valence (3): ", np.mean(valence_Score_Acc_3))
    print("Perfomance Mean Arousal (3): ", np.mean(arousal_Score_Acc_3))
    subjects = np.append(subjects, s)

class_0_LOW = total_elements_class0.sum()
class_1_HIGH = total_elements_class1.sum()

class_0_0_LOW = total_elements_class0_0.sum()
class_1_1_HIGH = total_elements_class1_1.sum()

csv_File().generate2(subjects, valence_Score_Acc_3, arousal_Score_Acc_3,
                     name_file)

print("\nTotal Class 0 (LOW VALENCE): ", class_0_LOW)
print("Total Class 1 (HIGH VALENCE): ", class_1_HIGH)

print("\nTotal Class 0 (LOW AROUSAL): ", class_0_0_LOW)
print("Total Class 1 (HIGH AROUSAL): ", class_1_1_HIGH)

os.system('say LR No Tangent Space acabado')


