from deap_utils.classifier import classifiers


class affectiveEmotions(object):

    def __init__(self, valence='v', arousal='a'):
        self.valence = valence
        self.arousal = arousal

    def getPerfomanceValence(self, x, y, classifier):

        if classifier == 'svm':
            performanceValence, stdValence = classifiers().svmClassifier(x, y, self.valence)
            return performanceValence, stdValence
        elif classifier == 'rf':
            performanceValence, stdValence = classifiers().randomForestClassifier(x, y, self.valence)
            return performanceValence, stdValence
        elif classifier == 'mlp':
            performanceValence, stdValence = classifiers().mlpClassifier(x, y, self.valence)
            return performanceValence, stdValence
        elif classifier == 'riemann':
            performanceValence, stdValence = classifiers().riemannianMDM(x, y, self.valence)
            return performanceValence, stdValence
        else:
            return 0
    def getPerfomanceArousal(self, x, y, classifier):

        if classifier == 'svm':
            performanceArousal, stdArousal = classifiers().svmClassifier(x, y, self.arousal)
            return performanceArousal, stdArousal
        elif classifier == 'rf':
            performanceArousal, stdArousal = classifiers().randomForestClassifier(x, y, self.arousal)
            return performanceArousal, stdArousal
        elif classifier == 'mlp':
            performanceArousal, stdArousal = classifiers().mlpClassifier(x, y, self.arousal)
            return performanceArousal, stdArousal
        elif classifier == 'riemann':
            performanceValence, stdValence = classifiers().riemannianMDM(x, y, self.arousal)
            return performanceValence, stdValence
        else:
            return 0
