import numpy as np
import gumpy

#SCIKIT LEARN
from sklearn.cross_validation import KFold, cross_val_score
#from sklearn.linear_model import LinearRegression
from sklearn.linear_model import LogisticRegression
from sklearn import cross_validation

class Frequencies(object):

    def __init__(self):
        self.clf = LogisticRegression()
        self.lo_alpha_beta_gamma, self.hi_alpha_beta_gamma = 15, 36
        # Define a monte-carlo cross-validation generator (reduce variance):
        self.cv = KFold(12800, 10, shuffle=True, random_state=42)
        # self.cv = KFold(12800, n_folds=12800)
        # self.loo = KFold(12800, n_folds=12800)

    def getAlfa_Beta_Gamma(self, data, s, labels_valence, labels_arousal):
        print("\n----ALPHA-BETA-GAMMA-START---")

        # first step is to filter the data
        flt_a_b_g = gumpy.signal.butter_bandpass(data, lo=self.lo_alpha_beta_gamma, hi=self.hi_alpha_beta_gamma)

        # PREPARE FOR PIPELINE
        # compute covariance matrices

        # Use scikit-learn Pipeline with cross_val_score function
        scoresV = cross_val_score(self.clf, flt_a_b_g, labels_valence, cv=self.cv)

        # Use scikit-learn Pipeline with cross_val_score function
        scoresA = cross_val_score(self.clf, flt_a_b_g, labels_arousal, cv=self.cv)


        return np.mean(scoresV * 100), np.mean(scoresA * 100)
        # flt_a_b_g = gumpy.signal.butter_bandpass(data, lo=self.lo_alpha_beta_gamma, hi=self.hi_alpha_beta_gamma)
        #
        # pr = np.zeros(len(labels_valence))
        # for train_idx, test_idx in self.cv:
        #     y_train, y_test = labels_valence[train_idx], labels_valence[test_idx]
        #     self.clf.fit(flt_a_b_g[train_idx], y_train)
        #     pr[test_idx] = self.clf.predict(flt_a_b_g[test_idx])
        #
        # acc = np.mean(pr == labels_valence)
        # print("ACC-V: ", acc)
        #
        # p2 = np.zeros(len(labels_arousal))
        # for train_idx, test_idx in self.cv:
        #     y_train, y_test = labels_arousal[train_idx], labels_arousal[test_idx]
        #     self.clf.fit(flt_a_b_g[train_idx], y_train)
        #     p2[test_idx] = self.clf.predict(flt_a_b_g[test_idx])
        #
        # acc2 = np.mean(p2 == labels_arousal)
        # print("ACC-A: ", acc2)

        #return acc*100,  acc2*100


        # flt_a_b_g = gumpy.signal.butter_bandpass(data, lo=self.lo_alpha_beta_gamma, hi=self.hi_alpha_beta_gamma)
        # X_train, X_test, y_train, y_test = cross_validation.train_test_split(flt_a_b_g, labels_valence, test_size=0.2)
        #
        # self.clf.fit(X_train, y_train)
        # accuracy = self.clf.score(X_test, y_test)
        # print("ACC-V: ", accuracy)
