import numpy as np
import scipy.io
from riemannian_utils.file_mat import matFile


def do(channel):

    print("CHANNEL 1------->: ", channel+1)
    videos = range(0, 40)

    #10 SEGMENTS OF 6 SECONDS
    datastart = 128*3; #384
    datalength = 8064-128*3; #7680
    framesize = 6*128; #768

    #400x768
    data_segmented = np.zeros((12800, framesize))


    path = '/Users/ricklicona/Downloads/DEAPDataset/data_preprocessed_matlab/'

    windows_size_ranges = np.array([], dtype=np.int64)
    for x in range(0, 11):
        windows_size_ranges = np.append(windows_size_ranges, framesize*x)

    labels_segmented_arousal = np.array([])
    labels_segmented_valence = np.array([])

    cont = 0
    for fl in range(0, 32):
        print("FILE------->: ", fl+ 1)
        if fl < 9:
            b = '0' + str(fl+1)
        else:
            b = str(fl+1)
        subject = path+'s'+b+'.mat'

        mat = scipy.io.loadmat(subject)
        X = np.array(mat['data'])
        X = X[:, :32, :]

        #SHAPE (40, 4)
        y = np.array(mat['labels'])

        #SHAPE (40, )
        y_valence = y[:, 0]
        y_arousal = y[:, 1]
        print("ARCHIVO: ", fl)
        for vi in videos:

            data = X[vi][channel].flatten()
            data1 = np.zeros(8064-datastart) #1, 7680
            data1[:] = data[datastart:8064]
            data2 = np.zeros(framesize)
            print("\nVIDEO: ", vi+1)
            for h in range(0, 10):
                if h <= 9:
                    data2[:] = data1[windows_size_ranges[h]:windows_size_ranges[h+1]]
                    print("\n-------------------------------------------------")
                    print("\nSegmentation: ", h+1, "\nRange X: ", windows_size_ranges[h], "\nRange y:", windows_size_ranges[h+1])
                    #print(data2[:])
                    if cont < 12800:
                        data_segmented[cont] = data2[:]

                    print("\nShape Data Segmentation: ", data2[:].shape)
                    op1 = 2
                    op2 = 2
                    combined = 1
                    if y_valence[vi] < 5:
                        op1 = 1     #Valence
                    if y_arousal[vi] < 5:
                        op2 = 1     #Arousal

                    labels_segmented_valence = np.append(labels_segmented_valence, op1)
                    labels_segmented_arousal = np.append(labels_segmented_arousal, op2)
                    cont = cont + 1
                else:
                    print("\nEnd Segmentation")

    datanew = {'data': data_segmented, 'labels_valence': labels_segmented_valence,
               'labels_arousal': labels_segmented_arousal}
    #FL = 32
    path_with_name = '/Users/ricklicona/PycharmProjects/deap_pBCI_Riemannian/DEAP/RIEMANNIAN_MDM/files_segmentation_10s/eeg_ch_' + str(
            channel+1) + '.mat'
    matFile().generate(path_with_name, datanew)
    print("\n SHAPE DATA SEGMENTED: ", data_segmented.shape)  # 12800x768
    print("\n SHAPE LABELS VALENCE: ", labels_segmented_valence.shape)  # (12800, )
    print("\n SHAPE LABELS AROUSAL: ", labels_segmented_arousal.shape)  # (12800,)



