import numpy as np
import gumpy

#SCIKIT LEARN
from sklearn.cross_validation import KFold
from sklearn.discriminant_analysis import LinearDiscriminantAnalysis


class Frequencies(object):

    def __init__(self):
        self.clf = LinearDiscriminantAnalysis(solver='lsqr', shrinkage='auto')
        self.lo_alpha_beta_gamma, self.hi_alpha_beta_gamma = 15, 36
        # Define a monte-carlo cross-validation generator (reduce variance):
        self.cv = KFold(12800, 10, shuffle=True, random_state=42)
        # self.cv = KFold(12800, n_folds=12800)
        # self.loo = KFold(12800, n_folds=12800)

    def getAlfa_Beta_Gamma(self, data, s, labels_valence, labels_arousal):
        print("\n----ALPHA-BETA-GAMMA-START---")

        flt_a_b_g = gumpy.signal.butter_bandpass(data, lo=self.lo_alpha_beta_gamma, hi=self.hi_alpha_beta_gamma)

        pr = np.zeros(len(labels_valence))
        for train_idx, test_idx in self.cv:
            y_train, y_test = labels_valence[train_idx], labels_valence[test_idx]
            self.clf.fit(flt_a_b_g[train_idx], y_train)
            pr[test_idx] = self.clf.predict(flt_a_b_g[test_idx])

        acc = np.mean(pr == labels_valence)

        p2 = np.zeros(len(labels_arousal))
        for train_idx, test_idx in self.cv:
            y_train, y_test = labels_arousal[train_idx], labels_arousal[test_idx]
            self.clf.fit(flt_a_b_g[train_idx], y_train)
            p2[test_idx] = self.clf.predict(flt_a_b_g[test_idx])

        acc2 = np.mean(p2 == labels_arousal)

        return acc*100,  acc2*100
